# 为什么设计beego和设计的思路

很多人会问为什么有那么多框架了，还要去实现一个框架呢？是不是大家都有自己实现框架的情节，我可以肯定的说不是，我说一下为什么设计beego的初衷

还记得当初写书的时候，我纯粹只是想把自己在学习Go语言中的一些体会写出来，由于我以前主要从事PHP和python的Web开发，所以想写一本Go如何来做Web实战的经验，刚开始的时候书的目录里面根本就没有框架实现这些章节，是写到后来发现其实对于Web开发者来说，一个微型的框架是非常有利于大家学习一个语言和快速进行应用开发的。

我以前经常用PHP的CI框架和python的tornado框架，这些框架都是非常轻量级的，轻量级就有利于我们：

- 第一节约我开发中一些常见问题的处理，用户只需要关注逻辑层面的东西
- 第二轻量级以至于他们的代码也是非常清晰的，我们可以通过阅读他们的源码来学习和体会这门语言的一些细节
- 第三对于项目开发者来说可以基于这些框架进行改造以适应自己的项目，从而实现二次框架的创造

所以基于上面这些的考虑，我就想实现一个类似这些语言的轻量级框架，所以我就在书的最后设计了两个章节来介绍和实现beego框架，这就是当初写beego框架的初衷。

有了这个初衷之后我就开始设计beego的执行逻辑，由于Go语言和python的思路比较接近，所以我就参考了tornado的思路来设计beego，你可以看到beego的RESTful处理完全和tornado的处理是一模一样的，通过controller层的Get、Post等方法来实现RESTFul。刚开始的时候路由参考的是[https://github.com/drone/routes](https://github.com/drone/routes)，这个的正则处理我觉得非常好，弥补了Go语言默认Mux中的路由功能，但是由于要采用RESTFul方式，所以我自己设计了一个接口，实现python中的继承思想。

整个的MVC逻辑中C是最重要的部分，这一块采用了我上面说的接口方式，M模块目前我还没想好怎么做，但是大家可以参考我的另一个开源项目beedb来实现数据的管理，V这一块目前采用了Go语言自带的模板引擎，但是实现了很多方便的模板函数。这样一个简易的框架就完成了，然后我就不断的完善周边的功能，包括表单处理、session处理、日志处理、配置处理、自动化运行等功能。

- [beego介绍](README.md)
- [安装入门](Install.md)
